<script setup>
import {onMounted, ref} from 'vue';
import {getUserData, isLogged, setAlertFun} from "@/common/ServerAPI.js";
import Alert from "@/components/Alert.vue";

onMounted(() => {
  if (isLogged()) {
    getUserData(basicData => {
      user.value = JSON.parse(basicData);
    });
  }
});

const user = ref(null);
let id = 0;

const alerts = ref([]);

setAlertFun(message => {
  alerts.value.push({
    id: ++id,
    message: message
  });
});

function dismiss(alert) {
  alerts.value.splice(alerts.value.indexOf(alert), 1);
}

</script>

<template>
  <div class="absolute text-center left-0 right-0 top-10" style="width: 100%; z-index: 99999999999">
    <Alert v-for="alert in alerts" :key="alert.id" :alert="alert" v-model:dismiss="dismiss"></Alert>
  </div>
  <div class="app bg-s4s-purple-600">
    <nav class="bg-s4s-purple-900 border-gray-200">
      <div class="max-w-screen-xl flex flex-wrap items-center justify-between mx-auto p-4">
        <router-link to="/" class="flex items-center space-x-3 rtl:space-x-reverse">
          <img src="@/assets/logo_darkmode.png" class="h-8" alt="S4S Logo" id="logo"/>
        </router-link>
        <div class="flex items-center md:order-2 space-x-3 md:space-x-0 rtl:space-x-reverse">
          <div class="pr-6">
            <button id="theme-toggle" type="button" @click="toggleDarkMode"
                    class="text-gray-500 hover:bg-gray-100 focus:outline-none focus:ring-4 focus:ring-gray-200 rounded-lg text-sm p-2.5">
              <svg id="theme-toggle-dark-icon" class="hidden w-5 h-5" fill="currentColor" viewBox="0 0 20 20"
                   xmlns="http://www.w3.org/2000/svg">
                <path d="M17.293 13.293A8 8 0 016.707 2.707a8.001 8.001 0 1010.586 10.586z"></path>
              </svg>
              <svg id="theme-toggle-light-icon" class="hidden w-5 h-5" fill="currentColor" viewBox="0 0 20 20"
                   xmlns="http://www.w3.org/2000/svg">
                <path
                    d="M10 2a1 1 0 011 1v1a1 1 0 11-2 0V3a1 1 0 011-1zm4 8a4 4 0 11-8 0 4 4 0 018 0zm-.464 4.95l.707.707a1 1 0 001.414-1.414l-.707-.707a1 1 0 00-1.414 1.414zm2.12-10.607a1 1 0 010 1.414l-.706.707a1 1 0 11-1.414-1.414l.707-.707a1 1 0 011.414 0zM17 11a1 1 0 100-2h-1a1 1 0 100 2h1zm-7 4a1 1 0 011 1v1a1 1 0 11-2 0v-1a1 1 0 011-1zM5.05 6.464A1 1 0 106.465 5.05l-.708-.707a1 1 0 00-1.414 1.414l.707.707zm1.414 8.486l-.707.707a1 1 0 01-1.414-1.414l.707-.707a1 1 0 011.414 1.414zM4 11a1 1 0 100-2H3a1 1 0 000 2h1z"
                    fill-rule="evenodd" clip-rule="evenodd"></path>
              </svg>
            </button>
          </div>
          <div class="flex text-sm bg-s4s-purple-600 rounded-md md:me-0 focus:ring-4 focus:ring-gray-300">
            <p class="text-white p-4">
              {{ user ? user.displayName : 'Login' }}
            </p>
          </div>
        </div>
      </div>
    </nav>

    <div class="p-6">
      <RouterView v-model:user="user"></RouterView>
    </div>
  </div>
</template>

<style>
#app,
.app {
  min-height: 100vh;
}
</style>